<style>

    /*Selected step in tracer*/
    .msg-tracer-line-selected {
        background-color: lightblue;
    }
    .msg-tracer-line {

    }

    .toggle-bp-button {
        border-width: thick;
        border-radius: 25%;
        color: red;
        background-color: darkred;
    }
</style>

<script type="text/javascript">

    $(()=>{
        const noderedAdminUrl = window.location.href.split('#')[0];
        if(!window.jsondiffpatch) {
            const $jsondiffpatch = $('<script>', {src: `${noderedAdminUrl}msg-tracer/jsondiffpatch.js`});
            $jsondiffpatch.appendTo(document.head);
        }

        let content = `

            <div id="tracer-tabs">
              <ul>
                <li><a href="#tracer-tabs-debug">Debug</a></li>
                <li><a href="#tracer-tabs-route">Route</a></li>
              </ul>

              <div id="tracer-tabs-debug">
                <br style="margin-top: 5pt"/>

                <button class="toggle-bp-button" id="toggleBp"><i class="fa fa-stop-circle-o"></i></button>
                <div>
                    <h4>Breakpoints:</h4>
                    <ul id="tracer-breakpoints-list"></ul>
                </div>

                <div>
                    <h4>Paused msg(s):</h4>
                    <ul id="tracer-msg-list"></ul>
                    <button id="tracer-release-all-button">Release All</button>
                    <button id="tracer-step-all-button">Step All</button>
                    <button id="tracer-kill-all-button">Kill All</button>
                </div>
              </div>

              <div id="tracer-tabs-route">
                <div style="margin-top: 5pt"></div>
                <button id="node-route-toggle-btn" style="width:70%;text-align: center">(Loading State...)</button>
                <button id="node-route-clear-btn" style="width:20pt; text-align: center; color: darkred">
                    <i class="fa fa-remove"></i>
                </button>
                <button id="node-route-settings-btn" style="width:20pt; text-align: center;">
                    <i class="fa fa-cog"></i>
                </button>
                <br/><br/>

                <div id="msg-tracer-settings" class="hidden">
                    <section>
                        <h4>Console</h4>
                        <div style="display: flex;flex-direction: row">
                            <label for="msg-tracer-output-console">Output to console</label>
                            <input id="msg-tracer-output-console" type="checkbox" />
                        </div>
                    </section>

                    <h4>Logstash UDP</h4>
                    <div style="display: flex;flex-direction: row">
                        <label for="msg-tracer-logging-enable">Enable</label>
                        <input id="msg-tracer-logging-enable" type="checkbox" />
                    </div>


                    <input id="msg-tracer-logging-host" type="text" placeholder="host" /><br/>
                    <input id="msg-tracer-logging-port" type="text" placeholder="port" /><br/>

                    <button id="msg-tracer-settings-save-btn">Save</button>
                    <button id="msg-tracer-settings-abort-btn">Abort</button>

                </div><br/>

                <button id="node-route-prev-btn" style="width:20pt; text-align: center;">
                    <i class="fa fa-arrow-left"></i>
                </button>
                <button id="node-route-next-btn" style="width:20pt; text-align: center;">
                    <i class="fa fa-arrow-right"></i>
                </button>

                <br/><br/>

                <pre id="node-contrib-route-log"></pre>
              </div>



            </div>

            <style>
                #msg-tracer-settings.hidden {
                    display: none;
                }
            </style>
`;

        let script = $(`<script>`, {html: `
            $( function() {
                $( "#tracer-tabs" ).tabs();
            } );
        `});
        content = $(content).append(script);

        // Adding the tracer tab to the sidebar
        RED.sidebar.addTab({
            id: "msg-tracer",
            label: 'MSG Tracer',
            name: 'MSG Tracer',
            iconClass: "fa fa-random",
            content: content,
            pinned: true,
            enableOnEdit: true
        });

        let entries = [];
        let currentIndex;
        const logEl = $('#node-contrib-route-log')
            , toggleButton = $('#node-route-toggle-btn')
            , clearButton = $('#node-route-clear-btn')
            , nextButton = $('#node-route-next-btn')
            , prevButton = $('#node-route-prev-btn')
            , settingsButton = $('#node-route-settings-btn')
            , settingsContainer = $('#msg-tracer-settings')
            , settings = {
                saveButton: $('#msg-tracer-settings-save-btn'),
                abortButton: $('#msg-tracer-settings-abort-btn'),
                enable: $('#msg-tracer-logging-enable'),
                host: $('#msg-tracer-logging-host'),
                port: $('#msg-tracer-logging-port'),
                console: $('#msg-tracer-output-console')
            }
            , toggleBpButton = $('#toggleBp')
            , bpList = $('#tracer-breakpoints-list')
            , msgList = $('#tracer-msg-list')
            , releaseAllButton = $('#tracer-release-all-button')
            , stepAllButton = $('#tracer-step-all-button')
            , killAllButton = $('#tracer-kill-all-button')
        ;

        let isOn = false;

        function updateButtonState() {
            toggleButton.text(isOn?'Stop':'Start');
        }


        function updateTracerLogSettingsViewState() {
            settings.enable.prop('checked', !!config.enableLogging);
            settings.console.prop('checked', !!config.console);
            settings.host.val(config.host?config.host:'');
            settings.port.val(config.port?(''+config.port):'');
        }

        function configReceived(cfg) {
            config = cfg;
            isOn = !!cfg.uiTrace;
            updateButtonState();
            updateTracerLogSettingsViewState();
            return cfg;
        }
        RED.comms.subscribe("msg-tracer/config", function (topic, cfg) {
            configReceived(cfg);
        });

        // Mark step as the selected step to view & focus on it
        function selectByIndex(index) {
            const $lineEl = $('#msg-tracer-line-'+index);
            $('.msg-tracer-line-selected').removeClass('msg-tracer-line-selected');
            $lineEl.addClass('msg-tracer-line-selected');
            currentIndex = index;
            RED.view.reveal(entries[index].node.id);
        }

        let DebugSettings = {};
        let CaughtMessages = {};
        let config = {};

        toggleBpButton.on('click', function() {
            const selection = RED.view.selection();
            for(let node of selection.nodes) {
                if(!DebugSettings[node.id]) {
                    DebugSettings[node.id] = {break:false};
                }

                const settings = DebugSettings[node.id];

                settings.break = !settings.break;
            }

            $.ajax({
                url: 'msg-tracer/debug',
                contentType: "application/json",
                dataType:'json',
                data: JSON.stringify(DebugSettings),
                type: 'PUT',
                error: function() {
                    alert(`Failed to change debug state`);
                },
                success: function() {}
            });

        });

        function updateCoughtMessages(caughtMessages) {
            msgList.html('');

            // clear svg breakpoint caught markers
            $('.tracer-caught').remove();

            for(let catchId of Object.keys(caughtMessages)) {
                const catchInfo = caughtMessages[catchId];

                // Add to list HTML
                const item = $(`<li></li>`);
                const $msgButton = $(`<a style="cursor: pointer;">${catchInfo.nodeId}</a>`);
                $msgButton.click(function () {
                    RED.view.reveal(catchInfo.nodeId);
                    RED.view.select(catchInfo.nodeId);
                });
                const editButton = $(`<span><a style="cursor: pointer;color: green;"><i class="fa fa-edit"></i></a> </span>`);
                editButton.click(function () {

                    $.ajax({
                        url: 'msg-tracer/caught/'+catchId+'/msg',
                        contentType: "application/json",
                        type: 'GET',
                        error: function(e) {
                            alert(`Failed to get msg: ${e}`);
                        },
                        success: function(msg) {
                            RED.editor.editJSON({
                                title:`Edit msg in ${catchInfo.nodeId}`,
                                value:msg?JSON.stringify(msg, null, 2):'{}',
                                complete: function(newJsonString) {
                                    try {
                                        const newJson = JSON.parse(newJsonString);
                                        const delta = jsondiffpatch.diff(msg, newJson);
                                        if(delta) {
                                            $.ajax({
                                                url: 'msg-tracer/caught/patch/'+catchId,
                                                contentType: "application/json",
                                                dataType:'json',
                                                type: 'PUT',
                                                data: JSON.stringify(delta),
                                                error: function(e) {
                                                    alert(`Failed to patch msg: ${e}`);
                                                },
                                                success: function() {}
                                            });
                                        }
                                    } catch (e) {
                                        alert('Patch parsing/diff failed locally');
                                    }
                                }
                            });
                        }
                    });
                });
                const releaseButton = $(` <button>release</button>`);
                releaseButton.click(function () {
                    $.ajax({
                        url: 'msg-tracer/caught/continue/'+catchId,
                        contentType: "application/json",
                        dataType:'json',
                        type: 'PUT',
                        error: function() {
                            alert(`Failed to continue msg execution`);
                        },
                        success: function() {}
                    });
                });
                const stepButton = $(` <button>step</button>`);
                stepButton.click(function () {
                    $.ajax({
                        url: 'msg-tracer/caught/step/'+catchId,
                        contentType: "application/json",
                        dataType:'json',
                        type: 'PUT',
                        error: function() {
                            alert(`Failed to step msg execution`);
                        },
                        success: function() {}
                    });
                });
                const killButton = $(` <button>kill</button>`);
                killButton.click(function () {
                    $.ajax({
                        url: 'msg-tracer/caught/kill/'+catchId,
                        contentType: "application/json",
                        dataType:'json',
                        type: 'PUT',
                        error: function() {
                            alert(`Failed to kill msg execution`);
                        },
                        success: function() {}
                    });
                });
                editButton.appendTo(item);
                $msgButton.appendTo(item);
                releaseButton.appendTo(item);
                stepButton.appendTo(item);
                killButton.appendTo(item);
                item.appendTo(msgList);


                // SVG related
                const selectorForNodeOnSvg = `g#${catchInfo.nodeId.replace('.','\\.')}`;
                const selectorForMarkerForNode = `${selectorForNodeOnSvg} .tracer-caught`;
                const markerExistsAlready = $(selectorForMarkerForNode).length>0;

                if(!markerExistsAlready) {
                    // Adding to SVG
                    // Count how many msg(s) await this node
                    let curNodeId = catchInfo.nodeId;
                    let count = 0;
                    for(let catchId of Object.keys(caughtMessages)) {
                        const catchInfo = caughtMessages[catchId];
                        if(catchInfo.nodeId === curNodeId) count++;
                    }

                    const text = $(document.createElementNS('http://www.w3.org/2000/svg', 'text'))
                        .attr({
                            class: 'tracer-caught',
                            x:20,
                            y:-6.5,
                            fill:'blue',
                            stroke:'none',
                            "font-size": '13pt'
                        })
                        .html(`${count}`);

                    const nodeElement = $(selectorForNodeOnSvg);
                    text.appendTo(nodeElement);
                }

            }

            CaughtMessages = caughtMessages;
        }

        releaseAllButton.click(function () {
            $.ajax({
                url: 'msg-tracer/caught/continue',
                contentType: "application/json",
                dataType:'json',
                type: 'POST',
                error: function() {
                    alert(`Failed to continue all msg execution`);
                },
                success: function() {}
            });
        });

        stepAllButton.click(function () {
            $.ajax({
                url: 'msg-tracer/caught/step',
                contentType: "application/json",
                dataType:'json',
                type: 'POST',
                error: function() {
                    alert(`Failed to step all msg execution`);
                },
                success: function() {}
            });
        });

        killAllButton.click(function () {
            $.ajax({
                url: 'msg-tracer/caught/kill',
                contentType: "application/json",
                dataType:'json',
                type: 'POST',
                error: function() {
                    alert(`Failed to kill all msg execution`);
                },
                success: function() {}
            });
        });

        function updateDebugSettings(debugSettings) {
            // Clean markers and tracer ui section
            bpList.html('');
            const allBreakPointMarkers = $(`g .tracer-breakpoint`);
            allBreakPointMarkers.remove();

            for(let settingsKey of Object.keys(debugSettings)) {
                const settings = debugSettings[settingsKey];
                if(!settings.break) {
                    const breakPointMarker = $(`g#${settingsKey.replace('.','\\.')} .tracer-breakpoint`);
                    breakPointMarker.remove();
                } else {
                    const markerEl = $(document.createElementNS('http://www.w3.org/2000/svg', 'circle'))
                        .attr({
                            class: 'tracer-breakpoint',
                            fill: 'red',
                            cx: 8,
                            cy: -11,
                            r: 7.5
                        });

                    const nodeElement = $(`g#${settingsKey.replace('.','\\.')}`);
                    markerEl.appendTo(nodeElement);

                    const item = $(`<li style="cursor: pointer;"><a>${settingsKey}</a></li>`);
                    item.click(function () {
                        RED.view.reveal(settingsKey);
                        RED.view.select(settingsKey);
                    });
                    item.appendTo(bpList);
                }
            }
            DebugSettings = debugSettings;
        }

        RED.comms.subscribe("msg-tracer/debug",function(topic, debugSettings) {
            updateDebugSettings(debugSettings);
        });

        RED.comms.subscribe("msg-tracer/caught",function(topic, caughtMessages) {
            updateCoughtMessages(caughtMessages);
        });

        RED.events.on('workspace:change', async function(e){
            for(let i=0;i<10;i++) {
                const nodesFoundInCurrentFlow = $('g.node.nodegroup').length > 0;
                if(nodesFoundInCurrentFlow) break;

                await(new Promise(res=>{setTimeout(res,500)}));
            }
            updateCoughtMessages(CaughtMessages);
            updateDebugSettings(DebugSettings);
        });

        RED.comms.subscribe("msg-tracer/log",function(topic, obj) {

            try {
                entries.push(obj);

                const dateObj = new Date(obj.time);
                const strForLog =
                    ('' + dateObj.getHours()).padStart(2,'0') + ':' +
                    ('' + dateObj.getMinutes()).padStart(2,'0') + '.' +
                    ('' + dateObj.getMilliseconds()).padStart(3,'0');

                const nodeObjectForLog = obj.node;
                const stepText = nodeObjectForLog.type + '@ ' + (nodeObjectForLog.name||nodeObjectForLog.label||'(NameLess)');

                const lineEl = document.createElement('span');
                lineEl.className = 'msg-tracer-line';
                lineEl.setAttribute('id','msg-tracer-line-'+(entries.length-1));
                $(lineEl).on('click', function () {
                    RED.editor.editJSON({title:`${nodeObjectForLog.id} ${stepText}`, value:obj.msg?JSON.stringify(obj.msg, null, 2):'{}'});
                });
                lineEl.style.cursor = 'zoom-in';

                lineEl.innerText = `${strForLog}: ${stepText}`;

                const linkToNodeEl = document.createElement('a');
                linkToNodeEl.innerText = ` #${nodeObjectForLog.id}`;
                linkToNodeEl.style.cursor = 'pointer';
                linkToNodeEl.style.color = 'blue';
                linkToNodeEl.onclick = function() {
                    const idx = parseInt(lineEl.getAttribute('id').split('msg-tracer-line-')[1]);
                    selectByIndex(idx);
                };

                const logElRowContainer = document.createElement('span');
                logElRowContainer.appendChild(lineEl);
                logElRowContainer.appendChild(linkToNodeEl);
                logElRowContainer.appendChild(document.createElement('br'));

                logEl.append(logElRowContainer);
            } catch(e) {}
        });

        settingsButton.on('click', function() {
            const isHidden = settingsContainer.hasClass('hidden');
            if(!isHidden) {
                settingsContainer.addClass('hidden');
                return;
            }
            settingsContainer.removeClass('hidden');

            updateTracerLogSettingsViewState();
        });

        clearButton.on('click', function() {
            entries = [];
            currentIndex = undefined;
            logEl.text('');
        });

        // Settings allow logging via udp
        settings.saveButton.on('click', function () {
            const patchCfg = {
                enableLogging: settings.enable.is(':checked'),
                host: settings.host.val(),
                port: parseInt(settings.port.val()) || 1,
                console: settings.console.is(':checked') || false
            };

            $.ajax({
                url: 'msg-tracer/config',
                contentType: "application/json",
                dataType:'json',
                data: JSON.stringify(patchCfg),
                type: 'PATCH',
                error: function() {
                    alert(`Failed to change trace state`);
                },
                success: function() {
                    settingsContainer.addClass('hidden');
                }
            });
        });

        settings.abortButton.on('click', function () {
            settingsContainer.addClass('hidden');
        });

        prevButton.on('click', function() {
            if(currentIndex === null || currentIndex === undefined) currentIndex = entries.length-1;
            else if(currentIndex > 0) {
                currentIndex--;
            }
            selectByIndex(currentIndex);
        });

        nextButton.on('click', function() {
            if(currentIndex === null || currentIndex === undefined) currentIndex = 0;
            else if(currentIndex < entries.length-1) {
                currentIndex++;
            }
            selectByIndex(currentIndex);
        });

        //
        // Shortcuts for browsing next/prev steps
        //
        RED.actions.add("msg-tracer:msg-tracer-next-node", function() {
            nextButton.trigger('click');
        });

        RED.actions.add("msg-tracer:msg-tracer-previous-node", function() {
            prevButton.trigger('click');
        });


        //
        // Shortcuts for breakpoints
        //
        RED.actions.add("msg-tracer:msg-tracer-toggle-breakpoint", function() {
            toggleBpButton.trigger('click');
        });

        RED.actions.add("msg-tracer:msg-tracer-bp-release-all", function() {
            releaseAllButton.trigger('click');
        });

        RED.actions.add("msg-tracer:msg-tracer-bp-step-all", function() {
            stepAllButton.trigger('click');
        });

        RED.actions.add("msg-tracer:msg-tracer-bp-kill-all", function() {
            killAllButton.trigger('click');
        });

        toggleButton.on('click', function() {
            const newCfg = {uiTrace: !isOn};
            $.ajax({
                url: 'msg-tracer/config',
                contentType: "application/json",
                dataType:'json',
                data: JSON.stringify(newCfg),
                type: 'PATCH',
                error: function() {
                    alert(`Failed to change trace state`);
                }
            });
        })
    })
</script>
